diff options
author | Junio C Hamano <junkio@cox.net> | 2005-08-08 22:57:57 -0700 |
---|---|---|
committer | Junio C Hamano <junkio@cox.net> | 2005-08-08 22:57:57 -0700 |
commit | c3958a7926ab20b90fe0767580b466698477f5b6 (patch) | |
tree | 80bf9ad53c61e817ad7269bb0f8f8e0a8ae8f1d9 | |
parent | e764a10b17610ed9b3969bdb351e09f9635eb0ab (diff) | |
parent | c882bc932f6702a935c748893536356b0bba11ce (diff) | |
download | git-c3958a7926ab20b90fe0767580b466698477f5b6.tar.gz git-c3958a7926ab20b90fe0767580b466698477f5b6.tar.xz |
Merge with master.
This merges commit
c882bc932f6702a935c748893536356b0bba11ce
from master into our head commit
e764a10b17610ed9b3969bdb351e09f9635eb0ab
Sincerely,
jit-merge command.
-rw-r--r-- | csum-file.c | 1 | ||||
-rwxr-xr-x | git-clone-dumb-http | 2 | ||||
-rwxr-xr-x | git-fetch-script | 2 | ||||
-rwxr-xr-x | git-ls-remote-script | 2 | ||||
-rwxr-xr-x | git-tag-script | 20 | ||||
-rw-r--r-- | pack-objects.c | 4 | ||||
-rw-r--r-- | path.c | 9 | ||||
-rw-r--r-- | sha1_file.c | 15 |
8 files changed, 43 insertions, 12 deletions
diff --git a/csum-file.c b/csum-file.c index 907efbf86..c66b9eb10 100644 --- a/csum-file.c +++ b/csum-file.c @@ -45,6 +45,7 @@ int sha1close(struct sha1file *f, unsigned char *result, int update) sha1flush(f, 20); if (close(f->fd)) die("%s: sha1 file error on close (%s)", f->name, strerror(errno)); + free(f); return 0; } diff --git a/git-clone-dumb-http b/git-clone-dumb-http index 8203c6762..50527086a 100755 --- a/git-clone-dumb-http +++ b/git-clone-dumb-http @@ -14,7 +14,7 @@ if [ -n "$GIT_SSL_NO_VERIFY" ]; then fi http_fetch () { # $1 = Remote, $2 = Local - curl -ns $curl_extra_args "$1" >"$2" + curl -nsf $curl_extra_args "$1" >"$2" } cd "$D" && diff --git a/git-fetch-script b/git-fetch-script index a0326f0e7..24f0a5ec8 100755 --- a/git-fetch-script +++ b/git-fetch-script @@ -15,7 +15,7 @@ http://* | https://*) fi _x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]' && _x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40" && - head=$(curl -ns $curl_extra_args "$merge_repo/$merge_head") && + head=$(curl -nsf $curl_extra_args "$merge_repo/$merge_head") && expr "$head" : "$_x40\$" >/dev/null || { echo >&2 "Failed to fetch $merge_head from $merge_repo" exit 1 diff --git a/git-ls-remote-script b/git-ls-remote-script index 921d3f846..31cdac8bf 100755 --- a/git-ls-remote-script +++ b/git-ls-remote-script @@ -46,7 +46,7 @@ http://* | https://* ) if [ -n "$GIT_SSL_NO_VERIFY" ]; then curl_extra_args="-k" fi - curl -ns $curl_extra_args "$peek_repo/info/refs" || exit 1 + curl -nsf $curl_extra_args "$peek_repo/info/refs" || exit 1 ;; rsync://* ) diff --git a/git-tag-script b/git-tag-script index 4917f9957..d3074a8b3 100755 --- a/git-tag-script +++ b/git-tag-script @@ -4,13 +4,14 @@ . git-sh-setup-script || die "Not a git archive" usage () { - echo >&2 "Usage: git-tag-script [-a | -s] [-f] tagname" + echo >&2 "Usage: git-tag-script [-a | -s] [-f] [-m "tag message"] tagname" exit 1 } annotate= signed= force= +message= while case "$#" in 0) break ;; esac do case "$1" in @@ -24,6 +25,11 @@ do -f) force=1 ;; + -m) + annotate=1 + shift + message="$1" + ;; -*) usage ;; @@ -48,10 +54,14 @@ tagger=$(git-var GIT_COMMITTER_IDENT) || exit 1 trap 'rm -f .tmp-tag* .tagmsg .editmsg' 0 if [ "$annotate" ]; then - ( echo "#" - echo "# Write a tag message" - echo "#" ) > .editmsg - ${VISUAL:-${EDITOR:-vi}} .editmsg || exit + if [ -z "$message" ]; then + ( echo "#" + echo "# Write a tag message" + echo "#" ) > .editmsg + ${VISUAL:-${EDITOR:-vi}} .editmsg || exit + else + echo "$message" > .editmsg + fi grep -v '^#' < .editmsg | git-stripspace > .tagmsg diff --git a/pack-objects.c b/pack-objects.c index ed24a3330..3d622787c 100644 --- a/pack-objects.c +++ b/pack-objects.c @@ -382,6 +382,10 @@ static void find_deltas(struct object_entry **list, int window, int depth) if (idx >= window) idx = 0; } + + for (i = 0; i < window; ++i) + free(array[i].data); + free(array); } int main(int argc, char **argv) @@ -68,8 +68,13 @@ int git_mkstemp(char *path, size_t len, const char *template) if ((env = getenv("TMPDIR")) == NULL) { strcpy(pch, "/tmp/"); len -= 5; - } else - len -= snprintf(pch, len, "%s/", env); + pch += 5; + } else { + size_t n = snprintf(pch, len, "%s/", env); + + len -= n; + pch += n; + } safe_strncpy(pch, template, len); diff --git a/sha1_file.c b/sha1_file.c index a17a6d13b..e9285c144 100644 --- a/sha1_file.c +++ b/sha1_file.c @@ -1165,6 +1165,7 @@ void *read_object_with_reference(const unsigned char *sha1, free(buffer); return NULL; } + free(buffer); /* Now we have the ID of the referred-to object in * actual_sha1. Check again. */ } @@ -1296,8 +1297,11 @@ int write_sha1_to_fd(int fd, const unsigned char *sha1) ssize_t size; unsigned long objsize; int posn = 0; - void *buf = map_sha1_file_internal(sha1, &objsize); + void *map = map_sha1_file_internal(sha1, &objsize); + void *buf = map; + void *temp_obj = NULL; z_stream stream; + if (!buf) { unsigned char *unpacked; unsigned long len; @@ -1313,7 +1317,7 @@ int write_sha1_to_fd(int fd, const unsigned char *sha1) memset(&stream, 0, sizeof(stream)); deflateInit(&stream, Z_BEST_COMPRESSION); size = deflateBound(&stream, len + hdrlen); - buf = xmalloc(size); + temp_obj = buf = xmalloc(size); /* Compress it */ stream.next_out = buf; @@ -1331,6 +1335,7 @@ int write_sha1_to_fd(int fd, const unsigned char *sha1) while (deflate(&stream, Z_FINISH) == Z_OK) /* nothing */; deflateEnd(&stream); + free(unpacked); objsize = stream.total_out; } @@ -1347,6 +1352,12 @@ int write_sha1_to_fd(int fd, const unsigned char *sha1) } posn += size; } while (posn < objsize); + + if (map) + munmap(map, objsize); + if (temp_obj) + free(temp_obj); + return 0; } |